Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0005840opensim[REGION] OpenSim Corepublic2012-01-03 17:452012-11-09 20:11
Reportermewtwo0641 
Assigned Tojustincc 
PrioritynormalSeveritycrashReproducibilityhave not tried
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target VersionFixed in Version 
Summary0005840: Teleports sometimes fail forcing a relog
DescriptionOccasionally when ever I try to teleport (whether it's a region crossing, teleport via map, or accepting tplure from another avatar) the teleport will never complete.

From what I have noticed, an incomplete teleport will be characterized by either the TP progress screen will either never complete and go away (forcing a relog); or it will take a really long time to time out then be returned to the region I was attempting to TP from and some (or all) of my attachments will be missing and unable to reattach until relog.

If attempting a region cross, the incomplete teleport will be noticed by the avatar walking/running/flying off into the distance infinitely, and will be forced to relog.

I didn't notice any errors in the console. I do notice that if the teleport does not complete it will not attempt to load any scripts the attachments may contain.

Script states will also occasionally be cleared out on teleport whether tp is successful or not.

After commit 469955889ed5499ed1dbb8fcc224d6912c651d06 it seemed to trigger for me a bit more often than before. Before the commit I would get this maybe once or twice a day, after the commit I noticed I would get it at least twice, sometimes as often as 3, 4 times, or more.

It seems to happen at random and I can't quite pinpoint what I'm doing to cause this reaction, but, I suspect having scripts in my attachments might have something to do with it as I seem to have less trouble crossing with no attachments/non scripted attachments. That is just my educated guess though.

I have been noticing that if the bug is going to trigger, then after a successful teleport scripted attachments will randomly decide not load their scripts after TP no matter how long I wait. Then if I attempt a teleport/region cross again before the scripts have loaded it will trigger the bug.
Steps To ReproduceOpenSim.ini script related settings:

AllowScriptCrossing = true
TrustBinaries = true
ScriptDelayFactor = 0.0
DeleteScriptsOnStartup = false

For this instance I was wearing 4 scripted attachments (one of which is a HUD) which contain a total of 35-40 scripts altogether.

1. Wear scripted attachments

2. Attempt to teleport (to another region, not within same region) or region cross (may take more than one try to trigger. Seems to trigger more often when making multiple teleports/region crosses that are close together in time)

3. If the bug is triggered you'll notice 1 of 2 things (depending on how you teleported)

    a. If standard teleport: TP progress screen will either never complete and go away (forcing a relog); or it will take a really long time to time out then be returned to the region attempted to TP from and some (or all) attachments will be missing and unable to reattach until relog.

    b. If attempting a region cross: The avatar will walk/run/fly off into the distance infinitely and will be forced to relog.
Additional InformationConsole output:

00:06:08 - [ENTITY TRANSFER MODULE]: Crossing agent mewtwo0641 Alito to 1001-1000 run
ning version SIMULATION/0.1
00:06:09 - [LOCAL SIMULATION CONNECTOR]: Found region Test Region 2 110061113965
9776 to send AgentUpdate
00:06:09 - [SCENE]: Incoming child agent update for 3557bf78-5e34-4e6c-b37c-2a5a
8527e3e2 in Test Region 2
00:06:09 - [ATTACHMENT]: Received attachment 014d8040-ac93-4d44-bcbf-341d6ea75ce
c, inworld asset id a95bc638-336f-493b-8ea0-16acd060879a
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <1.097586E-09, 0.07768758, -5.898499E-10>
00:06:09 - [ATTACHMENT]: Received attachment 1401f501-96ef-48eb-a9cb-4e7654a5658
b, inworld asset id 786b6008-0212-46b8-87bc-d6eabc8fea8f
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.06921, 0, 0.040769>
00:06:09 - [ATTACHMENT]: Received attachment 4614a500-1d44-4b70-85e7-a1e0adb78e5
e, inworld asset id 21748709-b088-498a-97e0-e3ce6d0e8a9f
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.08357777, -0.0009133071, -0.0004721889>
00:06:09 - [ATTACHMENT]: Received attachment 62554bfe-78fe-4b0a-9e62-b43c8e68124
0, inworld asset id d1108645-c573-41cb-98c1-ef8ae8e06e50
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0, 0, 0>
00:06:09 - [ATTACHMENT]: Received attachment 74990623-3f1e-4781-9a08-90f20764678
3, inworld asset id f4f7d9b2-61a5-4ac7-81ff-d11c642ce418
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.0567, 0.0579, 0.1064>
00:06:09 - [ATTACHMENT]: Received attachment 7ea3a421-cfe9-43e6-b441-f0c92454c71
6, inworld asset id fde4b831-e7bc-4c7a-b853-8673727617b2
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0.0005, 0.0038, -0.0215>
00:06:09 - [ATTACHMENT]: Received attachment 84eeffd6-43bb-4ca4-8145-14ddc042227
3, inworld asset id ef5eb9ac-b27b-4f2c-8d41-5886883769e9
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.09546616, 3.864238E-10, 2.645508E-09>
00:06:09 - [ATTACHMENT]: Received attachment 8828240f-cf15-438e-9694-c212a4c7def
6, inworld asset id ecdb7190-5d13-4ab5-b79e-64f9c28dd0e6
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.0567, -0.0579, 0.1064>
00:06:09 - [ATTACHMENT]: Received attachment b09ea88d-8359-4ba5-9d73-96a4ac478a8
5, inworld asset id 7b0136b1-900d-491d-8315-3cc6f633e2c4
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <1.491224E-11, -0.07316594, -3.096983E-10>
00:06:09 - [ATTACHMENT]: Received attachment ba0db81e-aec0-48d0-baf6-c8e50622273
3, inworld asset id e36003df-9d4b-4bfe-b0c2-f953738bd39f
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0.01953944, 0.007730848, -0.03570046>
00:06:09 - [ATTACHMENT]: Received attachment c905352a-3249-4904-ac69-a921c783dba
7, inworld asset id f1206001-ab02-4b91-9c0c-5240f8f43d9d
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0, 0, 0>
00:06:09 - [ATTACHMENT]: Received attachment c9a80ef6-93cb-4500-9593-5a74f65301d
4, inworld asset id 88b7788f-5d77-491e-9334-0b021e5e003f
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0.05592674, 0.0002268362, -0.03850368>
00:06:09 - [ATTACHMENT]: Received attachment d118324d-8f72-46bb-aef3-2e1d0b302af
d, inworld asset id 99016042-8e27-4391-8a60-c30671b9d357
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0, -0.0900206, -0.1144547>
00:06:09 - [ATTACHMENT]: Received attachment d4b3da72-6554-4a0d-813d-9e8512602ee
4, inworld asset id 84261ab5-4215-48dc-aefc-16e1c3cd5bae
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.066665, 0, 0.049093>
00:06:09 - [ATTACHMENT]: Received attachment e512c79c-ea7b-41df-ba87-715486b18a4
8, inworld asset id acd9db34-6e03-4134-b5b3-444f19944603
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0, 0.06970888, 0.1382979>
00:06:09 - [ATTACHMENT]: Received attachment ebb11264-a1fa-4ecd-a79a-d65b2a5c4ab
7, inworld asset id d298a41f-db7f-405b-b315-0b08451e10a8
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <0.01913717, 0.007295324, -0.03769049>
00:06:09 - [ATTACHMENT]: Received attachment ef2525ba-bced-4822-afad-a0a84bbe20a
9, inworld asset id 0e051b5c-24a9-471f-8c9d-685b4b089b51
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.000589621, 0.305723, -0.07440926>
00:06:09 - [ATTACHMENT]: Received attachment fbd56eba-252a-466b-ba5a-9f903d7b4b7
f, inworld asset id fff418ba-b140-4c4c-a6dd-7d50df5c5b69
00:06:09 - [ATTACHMENT]: Attach to avatar 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 a
t position <-0.09748615, 0, 0.177889>
00:06:09 - [ENTITY TRANSFER MODULE]: Sending new CAPS seed url http://192.168.1. [^]
100:9000/CAPS/07549b02-20ec-47d4-96e3-92d24d2a4f420000/ to client 3557bf78-5e34-
4e6c-b37c-2a5a8527e3e2
00:06:09 - [SCENE PRESENCE]: Making mewtwo0641 Alito a child agent in Test Region 3
00:06:09 - [SCENE PRESENCE]: Closing child agents. Checking 7 regions in Test Re
gion 3
00:06:09 - [SCENE PRESENCE]: Closing 1 child agents
00:06:09 - [INTERGRID]: Sending close agent 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2
 to region at 1001-1002
00:06:09 - [ENTITY TRANSFER MODULE]: Crossing agent mewtwo0641 Alito completed.
00:07:19 - [CLIENT]: Got a logout request for mewtwo0641 Alito in Test Region 3
00:07:19 - [CLIENT]: Close has been called for mewtwo0641 Alito attached to scene Tes
t Region 3
00:07:19 - [SCENE]: Removing child agent 3557bf78-5e34-4e6c-b37c-2a5a8527e3e2 fr
om region Test Region 3
Region (root) #
TagsNo tags attached.
Git Revision or version numberr/17676
Run Mode Standalone (Multiple Regions)
Physics EngineODE
Environment.NET / Windows32
Mono VersionNone
ViewerAll
Attached Files

- Relationships
related to 0005787closed Teleport Fail Causes Region Neighbors To Disappear in View; all next teleports fail, requires relog 
parent of 0005702new Loss of script state if TP/Region cross is not completely successful 
Not all the children of this issue are yet resolved or closed.

-  Notes
(0021275)
mewtwo0641 (reporter)
2012-04-21 08:33

Slight update on this:
I have noticed that if the teleports are done before attachment scripts are loaded, then this issue is triggered more consistently. In some instances there is a good 10 - 15 seconds before scripts are loaded after a teleport and if another teleport is attempted before they are loaded it will cause this issue to happen.
(0021539)
justincc (administrator)
2012-05-25 18:41

You might want to try git master ab59c0a, it may have improved the situation. However, both the source and destination regions would need to be updated to at least this commit.
(0021572)
mewtwo0641 (reporter)
2012-05-28 09:15

Hi Justin, just downloaded and gave commit 7fd3878 (r19146) a test run. Things seem to be running a LOT smoother now as far as teleports go. I have not run into a failed teleport yet. Tested using random region crossings, TP from maps, and also double click teleports within same region and into different regions. Although, and I am not sure if this is related or not to this issue, I have noticed that on occasion a region will disappear from view of the avatar (but will still show up on map). If I attempt to teleport or region cross to the missing region it will attempt teleport / cross for 15 seconds or so and then return me to the previous region. The only way to get the region to appear that I can tell is to relog.

Thanks! =)
(0021579)
justincc (administrator)
2012-05-28 14:32

Thanks mewtwo. I'll keep this mantis open for the other problem you reported - I suspect this is something to do with sending (or perhaps not sending in this case) EnableSimulator messages.
(0021652)
mewtwo0641 (reporter)
2012-06-15 15:58

I have been doing a bit more testing on this, turns out that this issue can still be triggered, although it is quite a bit better than it has been. Have had mixed results between v1.23 base viewers and v2/3 base viewers but the end result is the same.

Steps to reproduce:

1. Wear attachments with scripts (I had a total of about 15 - 20 scripts across all my attachments in my testing)and cross over into another region via flying (Fly since it is the quickest) and as soon as you can control the avatar again, immediately fly back into the previous region, then fly back into the other region.

    a. The issue seems to be triggered more consistently if step 1 is done quickly, without giving the server much time to load script attachments in between crosses.

2. Once the issue is triggered a few things should be noticeable:
    a. Doing this seems to confuse the server and script engine as I'll get script not started errors once triggered. (ERROR - OpenSim.Region.ScriptEngine.XEngine.XEngine [Script]: SceneObjectPart with localID 1581197762 unavailable. Script NOT started.)

    b. There will be a loss of all script states in all attachments

    c. Any future teleports will fail until relog

    d. Surrounding regions may or may not become invisible until relog
(0022014)
mewtwo0641 (reporter)
2012-08-10 08:40

Not sure if this is related but I am now getting an exception when teleports fail (once the avatar is logged out)

Exception:

2012-08-10 10:18:45,580 ERROR - OpenSim.Region.Framework.Scenes.Scene [SCENE]: Exception removing mewtwo0641 Alito from Test Region 2,
System.NullReferenceException: Object reference not set to an instance of an object.
   at OpenSim.Region.Framework.Scenes.ScenePresence.Close() in c:\Users\admin\Desktop\opensim-337ea01\OpenSim\Region\Framework\Scenes\ScenePresence.cs:line 3390
   at OpenSim.Region.Framework.Scenes.Scene.RemoveClient(UUID agentID, Boolean closeChildAgents) in c:\Users\admin\Desktop\opensim-337ea01\OpenSim\Region\Framework\Scenes\Scene.cs:line 3320
(0022015)
SignpostMarv (reporter)
2012-08-10 09:04

It looks like the lines you're experiencing your latest issue with were removed at some point between commit 337ea01 and latest master. Have you tried latest master or 0.7.4 rc1?
(0022016)
mewtwo0641 (reporter)
2012-08-10 09:33

I have tried the latest master but I didn't give it much testing because of an issue described here http://opensim-users.2152040.n2.nabble.com/Scripts-in-attachments-are-not-responding-on-master-td7578373.html [^]

I will give 0.7.4 RC1 a try though and see what happens.
(0022017)
mewtwo0641 (reporter)
2012-08-10 10:15

Just finished giving 0.7.4 RC1 a go. I don't see the exception anymore. Teleports in general seem to be much more stable when it comes to scripted attachments as well. Thanks for the tip =) Will report back if I find anything later.

PS. The scripts in attachments not responding issue was also present in 0.7.4 RC1 on my first test and it's a strange one... I am not sure what I did amidst my recompiling of scripts in my attachments but suddenly they all started working again. I believe when I edited one of my attachments and picked "Set scripts in selection to running" they all started working suddenly. I know this is probably completely irrelevant to this mantis so I will file a separate mantis if it keeps popping up.

- Issue History
Date Modified Username Field Change
2012-01-03 17:45 mewtwo0641 New Issue
2012-01-03 17:49 mewtwo0641 Description Updated View Revisions
2012-01-03 17:52 mewtwo0641 Relationship added parent of 0005702
2012-01-06 23:20 LaniGlobal Relationship added related to 0005787
2012-04-21 08:33 mewtwo0641 Note Added: 0021275
2012-05-25 18:41 justincc Note Added: 0021539
2012-05-25 18:41 justincc Assigned To => justincc
2012-05-25 18:41 justincc Status new => feedback
2012-05-28 09:15 mewtwo0641 Note Added: 0021572
2012-05-28 09:15 mewtwo0641 Status feedback => assigned
2012-05-28 14:32 justincc Note Added: 0021579
2012-06-15 15:58 mewtwo0641 Note Added: 0021652
2012-08-10 08:40 mewtwo0641 Note Added: 0022014
2012-08-10 09:04 SignpostMarv Note Added: 0022015
2012-08-10 09:33 mewtwo0641 Note Added: 0022016
2012-08-10 10:15 mewtwo0641 Note Added: 0022017
2012-08-18 04:32 DMX04 Issue cloned: 0006220
2012-11-09 20:11 justincc Status assigned => closed
2012-11-09 20:11 justincc Resolution open => fixed


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker